searchNodes=[{"doc":"","ref":"Kaffy.Cache.Client.html","title":"Kaffy.Cache.Client","type":"module"},{"doc":"","ref":"Kaffy.Cache.Client.html#add_cache/4","title":"Kaffy.Cache.Client.add_cache/4","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Kaffy.Cache.Client.html#child_spec/1","title":"Kaffy.Cache.Client.child_spec/1","type":"function"},{"doc":"","ref":"Kaffy.Cache.Client.html#get_cache/2","title":"Kaffy.Cache.Client.get_cache/2","type":"function"},{"doc":"","ref":"Kaffy.Cache.Client.html#start_link/1","title":"Kaffy.Cache.Client.start_link/1","type":"function"},{"doc":"ResourceAdmin modules should be created for every schema you want to customize/configure in Kaffy. If you have a schema like MyApp.Products.Product , you should create an admin module with name MyApp.Products.ProductAdmin and add functions documented in this module to customize the behavior. All functions are optional.","ref":"Kaffy.ResourceAdmin.html","title":"Kaffy.ResourceAdmin","type":"module"},{"doc":"authorized?/2 takes the schema and the current Plug.Conn struct and should return a boolean value. Returning false will prevent the access of this resource for the current user/request. If authorized?/2 is not defined, Kaffy will return true. Example: def authorized? ( _schema , _conn ) do true end","ref":"Kaffy.ResourceAdmin.html#authorized?/2","title":"Kaffy.ResourceAdmin.authorized?/2","type":"function"},{"doc":"","ref":"Kaffy.ResourceAdmin.html#collect_links/2","title":"Kaffy.ResourceAdmin.collect_links/2","type":"function"},{"doc":"","ref":"Kaffy.ResourceAdmin.html#collect_pages/1","title":"Kaffy.ResourceAdmin.collect_pages/1","type":"function"},{"doc":"","ref":"Kaffy.ResourceAdmin.html#collect_widgets/1","title":"Kaffy.ResourceAdmin.collect_widgets/1","type":"function"},{"doc":"create_changeset/2 takes the record and the changes and should return a changeset for creating a new record. If create_changeset/2 is not defined, Kaffy will try to call schema.changeset/2 and if that's not defined, Ecto.Changeset.change/2 will be called. Example: def create_changeset ( schema , attrs ) do MyApp.Blog.Post . create_changeset ( schema , attrs ) end","ref":"Kaffy.ResourceAdmin.html#create_changeset/2","title":"Kaffy.ResourceAdmin.create_changeset/2","type":"function"},{"doc":"","ref":"Kaffy.ResourceAdmin.html#custom_index_query/3","title":"Kaffy.ResourceAdmin.custom_index_query/3","type":"function"},{"doc":"","ref":"Kaffy.ResourceAdmin.html#custom_links/2","title":"Kaffy.ResourceAdmin.custom_links/2","type":"function"},{"doc":"","ref":"Kaffy.ResourceAdmin.html#custom_pages/2","title":"Kaffy.ResourceAdmin.custom_pages/2","type":"function"},{"doc":"","ref":"Kaffy.ResourceAdmin.html#custom_show_query/3","title":"Kaffy.ResourceAdmin.custom_show_query/3","type":"function"},{"doc":"","ref":"Kaffy.ResourceAdmin.html#find_page/2","title":"Kaffy.ResourceAdmin.find_page/2","type":"function"},{"doc":"form_fields/1 takes a schema and returns a keyword list of fields and their options for the new/edit form. Supported options are: :label , :type , :choices , and :permission :type can be any ecto type in addition to :file and :textarea If :choices is provided, it must be a keyword list and the field will be rendered as a &lt;select&gt; element regardless of the actual field type. Setting :permission to :read will make the field non-editable. It is :write by default. If you want to remove a field from being rendered, just remove it from the list. If form_fields/1 is not defined, Kaffy will return all the fields with their default types based on the schema. Example: def form_fields ( _schema ) do [ title : %{ label : &quot;Subject&quot; } , slug : nil , image : %{ type : :file } , status : %{ choices : [ { &quot;Pending&quot; , &quot;pending&quot; } , { &quot;Published&quot; , &quot;published&quot; } ] } , body : %{ type : :textarea , rows : 3 } , views : %{ permission : :read } ] end","ref":"Kaffy.ResourceAdmin.html#form_fields/1","title":"Kaffy.ResourceAdmin.form_fields/1","type":"function"},{"doc":"","ref":"Kaffy.ResourceAdmin.html#humanize_term/1","title":"Kaffy.ResourceAdmin.humanize_term/1","type":"function"},{"doc":"index/1 takes the schema module and should return a keyword list of fields and their options. Supported options are :name and :value . Both options can be a string or an anonymous function. If a function is provided, the current entry is passed to it. If index/1 is not defined, Kaffy will return all the fields of the schema and their default values. Example: def index ( _schema ) do [ id : %{ name : &quot;ID&quot; , value : fn post -&gt; post . id + 100 end } , title : nil , # this will render the default name for this field (Title) and its default value (post.title) views : %{ name : &quot;Hits&quot; , value : fn post -&gt; post . views + 10 end } , published : %{ name : &quot;Published?&quot; , value : fn post -&gt; published? ( post ) end } , comment_count : %{ name : &quot;Comments&quot; , value : fn post -&gt; comment_count ( post ) end } ] end","ref":"Kaffy.ResourceAdmin.html#index/1","title":"Kaffy.ResourceAdmin.index/1","type":"function"},{"doc":"","ref":"Kaffy.ResourceAdmin.html#list_actions/2","title":"Kaffy.ResourceAdmin.list_actions/2","type":"function"},{"doc":"ordering/1 takes a schema and returns how the entries should be ordered. If ordering/1 is not defined, Kaffy will return [desc: :id] . Example: def ordering ( _schema ) do [ asc : :title ] end","ref":"Kaffy.ResourceAdmin.html#ordering/1","title":"Kaffy.ResourceAdmin.ordering/1","type":"function"},{"doc":"This is useful for names that cannot be plural by adding an &quot;s&quot; at the end. Like &quot;Category&quot; =&gt; &quot;Categories&quot; or &quot;Person&quot; =&gt; &quot;People&quot;. If plural_name/1 is not defined, Kaffy will use the singular name and add an &quot;s&quot; to it (e.g. Posts). Example: def plural_name ( _schema ) do &quot;Categories&quot; end","ref":"Kaffy.ResourceAdmin.html#plural_name/1","title":"Kaffy.ResourceAdmin.plural_name/1","type":"function"},{"doc":"","ref":"Kaffy.ResourceAdmin.html#resource_actions/2","title":"Kaffy.ResourceAdmin.resource_actions/2","type":"function"},{"doc":"search_fields/1 takes a schema and must return a list of :string fields to search against when typing in the search box. If search_fields/1 is not defined, Kaffy will return all the :string fields of the schema. Example: def search_fields ( _schema ) do [ :title , :slug , :body ] end","ref":"Kaffy.ResourceAdmin.html#search_fields/1","title":"Kaffy.ResourceAdmin.search_fields/1","type":"function"},{"doc":"This function should return a string for the singular name of a resource. If singular_name/1 is not defined, Kaffy will use the name of the last part of the schema module (e.g. Post in MyApp.Blog.Post) This is useful for when you have a schema but you want to display its name differently. If you have &quot;Post&quot; and you want to display &quot;Article&quot; for example. Example: def singular_name ( _schema ) do &quot;Article&quot; end","ref":"Kaffy.ResourceAdmin.html#singular_name/1","title":"Kaffy.ResourceAdmin.singular_name/1","type":"function"},{"doc":"update_changeset/2 takes the record and the changes and should return a changeset for updating an existing record. If update_changeset/2 is not defined, Kaffy will try to call schema.changeset/2 and if that's not defined, Ecto.Changeset.change/2 will be called. Example: def update_changeset ( schema , attrs ) do MyApp.Blog.Post . create_changeset ( schema , attrs ) end","ref":"Kaffy.ResourceAdmin.html#update_changeset/3","title":"Kaffy.ResourceAdmin.update_changeset/3","type":"function"},{"doc":"","ref":"Kaffy.ResourceAdmin.html#widgets/2","title":"Kaffy.ResourceAdmin.widgets/2","type":"function"},{"doc":"","ref":"Kaffy.ResourceError.html","title":"Kaffy.ResourceError","type":"module"},{"doc":"","ref":"Kaffy.ResourceError.html#display_errors/2","title":"Kaffy.ResourceError.display_errors/2","type":"function"},{"doc":"","ref":"Kaffy.ResourceError.html#form_error_border_class/2","title":"Kaffy.ResourceError.form_error_border_class/2","type":"function"},{"doc":"","ref":"Kaffy.ResourceForm.html","title":"Kaffy.ResourceForm","type":"module"},{"doc":"","ref":"Kaffy.ResourceForm.html#bare_form_field/3","title":"Kaffy.ResourceForm.bare_form_field/3","type":"function"},{"doc":"","ref":"Kaffy.ResourceForm.html#form_field/4","title":"Kaffy.ResourceForm.form_field/4","type":"function"},{"doc":"","ref":"Kaffy.ResourceForm.html#form_help_text/1","title":"Kaffy.ResourceForm.form_help_text/1","type":"function"},{"doc":"","ref":"Kaffy.ResourceForm.html#form_label/2","title":"Kaffy.ResourceForm.form_label/2","type":"function"},{"doc":"","ref":"Kaffy.ResourceForm.html#form_label_string/1","title":"Kaffy.ResourceForm.form_label_string/1","type":"function"},{"doc":"","ref":"Kaffy.ResourceForm.html#get_field_error/2","title":"Kaffy.ResourceForm.get_field_error/2","type":"function"},{"doc":"","ref":"Kaffy.ResourceForm.html#kaffy_input/5","title":"Kaffy.ResourceForm.kaffy_input/5","type":"function"},{"doc":"","ref":"Kaffy.ResourceParams.html","title":"Kaffy.ResourceParams","type":"module"},{"doc":"","ref":"Kaffy.ResourceParams.html#decode_map_fields/3","title":"Kaffy.ResourceParams.decode_map_fields/3","type":"function"},{"doc":"Kaffy.Routes must be &quot;used&quot; in your phoenix routes: use Kaffy.Routes , scope : &quot;/admin&quot; , pipe_through : [ :browser , :authenticate ] :scope defaults to &quot;/admin&quot; :pipe_through defaults to kaffy's [:kaffy_browser]","ref":"Kaffy.Routes.html","title":"Kaffy.Routes","type":"module"},{"doc":"","ref":"Kaffy.Scheduler.Supervisor.html","title":"Kaffy.Scheduler.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Kaffy.Scheduler.Supervisor.html#child_spec/1","title":"Kaffy.Scheduler.Supervisor.child_spec/1","type":"function"},{"doc":"","ref":"Kaffy.Scheduler.Supervisor.html#start_link/1","title":"Kaffy.Scheduler.Supervisor.start_link/1","type":"function"},{"doc":"","ref":"Kaffy.Scheduler.Task.html","title":"Kaffy.Scheduler.Task","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Kaffy.Scheduler.Task.html#child_spec/1","title":"Kaffy.Scheduler.Task.child_spec/1","type":"function"},{"doc":"","ref":"Kaffy.Scheduler.Task.html#start_link/1","title":"Kaffy.Scheduler.Task.start_link/1","type":"function"},{"doc":"","ref":"Kaffy.Tasks.html","title":"Kaffy.Tasks","type":"module"},{"doc":"","ref":"Kaffy.Tasks.html#collect_tasks/0","title":"Kaffy.Tasks.collect_tasks/0","type":"function"},{"doc":"","ref":"Kaffy.Tasks.html#tasks_info/0","title":"Kaffy.Tasks.tasks_info/0","type":"function"},{"doc":"","ref":"readme.html","title":"README","type":"extras"},{"doc":"Kaffy was created out of a need to have a powerfully simple, flexible, and customizable admin interface without the need to touch the current codebase. It was inspired by django's lovely built-in admin app and rails' powerful activeadmin gem.","ref":"readme.html#introduction","title":"README - Introduction","type":"extras"},{"doc":"Introduction Sections Sponsors Demo Minimum Requirements Installation Add kaffy as a dependency These are the minimum configurations required Customizations Configurations Breaking change in v0.9 Dashboard page Side Menu Custom Links Custom Pages Index pages Form Pages Association Forms Custom Form Fields Customize the Queries Extensions Embedded Schemas and JSON Fields Search Authorization Changesets Singular vs Plural Custom Actions Single Resource Actions List Actions Callbacks Overwrite actions Scheduled Tasks The Driving Points","ref":"readme.html#sections","title":"README - Sections","type":"extras"},{"doc":"Become a sponsor through Kaffy's OpenCollective page.","ref":"readme.html#sponsors","title":"README - Sponsors","type":"extras"},{"doc":"Check out the simple demo here","ref":"readme.html#demo","title":"README - Demo","type":"extras"},{"doc":"elixir 1.8.0 phoenix 1.4.0","ref":"readme.html#minimum-requirements","title":"README - Minimum Requirements","type":"extras"},{"doc":"Add kaffy as a dependency def deps do [ { :kaffy , &quot;~&gt; 0.9.0&quot; } ] end These are the minimum configurations required # in your router.ex use Kaffy.Routes , scope : &quot;/admin&quot; , pipe_through : [ :some_plug , :authenticate ] # :scope defaults to &quot;/admin&quot; # :pipe_through defaults to kaffy&#39;s [:kaffy_browser] # when providing pipelines, they will be added after :kaffy_browser # so the actual pipe_through for the previous line is: # [:kaffy_browser, :some_plug, :authenticate] # in your endpoint.ex # configure the path to your application static assets in :at # the path must end with `/kaffy` plug Plug.Static , at : &quot;/kaffy&quot; , # or &quot;/path/to/your/static/kaffy&quot; from : :kaffy , gzip : false , only : ~w(assets) # in your config/config.exs config :kaffy , otp_app : :my_app , ecto_repo : MyApp.Repo , router : MyAppWeb.Router Note that providing pipelines with the :pipe_through option will add those pipelines to kaffy's :kaffy_browser pipeline which is defined as follows: pipeline :kaffy_browser do plug :accepts , [ &quot;html&quot; , &quot;json&quot; ] plug :fetch_session plug :fetch_flash plug :protect_from_forgery plug :put_secure_browser_headers end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Configurations Breaking change in v0.9 If you're upgrading from an earlier version to v0.9, you need to replace your :schemas with :resources . If you don't specify a resources option in your configs, Kaffy will try to auto-detect your schemas and your admin modules. Admin modules should be in the same namespace as their respective schemas in order for kaffy to detect them. For example, if you have a schema MyApp.Products.Product , its admin module should be MyApp.Products.ProductAdmin . Otherwise, if you'd like to explicitly specify your schemas and their admin modules, you can do like the following: # config.exs config :kaffy , admin_title : &quot;My Awesome App&quot; , admin_logo : &quot;/images/logo.png&quot; , admin_logo_mini : &quot;/images/logo-mini.png&quot; , hide_dashboard : false , home_page : [ kaffy : :dashboard ] , ecto_repo : MyApp.Repo , router : MyAppWeb.Router , resources : &amp; MyApp.Kaffy.Config . create_resources / 1 # in your custom resources function defmodule MyApp.Kaffy.Config do def create_resources ( _conn ) do [ blog : [ name : &quot;My Blog&quot; , # a custom name for this context/section. resources : [ # this line used to be &quot;schemas&quot; in pre v0.9 post : [ schema : MyApp.Blog.Post , admin : MyApp.SomeModule.Anywhere.PostAdmin ] , comment : [ schema : MyApp.Blog.Comment ] , tag : [ schema : MyApp.Blog.Tag ] ] ] , inventory : [ name : &quot;Inventory&quot; , resources : [ category : [ schema : MyApp.Products.Category , admin : MyApp.Products.CategoryAdmin ] , product : [ schema : MyApp.Products.Product , admin : MyApp.Products.ProductAdmin ] ] ] ] end end Starting with Kaffy v0.9, the :resources option can take a literal list or a function. If a function is provided, it should take a conn and return a list of contexts and schemas like in the example above. Passing a conn to the function provides more flexibility and customization to your resources list. You can set the :hide_dashboard option to true to hide the dashboard link from the side menu. To change the home page, change the :home_page option to one of the following: [kaffy: :dashboard] for the default dashboard page. [schema: [&quot;blog&quot;, &quot;post&quot;]] to make the home page the index page for the Post schema under the 'Blog' context. [page: &quot;my-custom-page&quot;] to make the custom page with the :slug &quot;my-custom-page&quot; the home page. See the Custom Pages section below. Note that, for auto-detection to work properly, schemas in different contexts should have different direct &quot;prefix&quot; namespaces. That is: # auto-detection works properly with this: MyApp.Posts.Post MyApp.Posts.Category MyApp.Products.Product MyApp.Products.Category # this Category will not be confused with Posts.Category # auto-detection will be confused with this: # both Category schemas have the same &quot;Schemas&quot; prefix. MyApp.Posts.Schemas.Post MyApp.Posts.Schemas.Category MyApp.Products.Schemas.Product MyApp.Products.Schemas.Category # To fix this, define resources manually: resources : [ posts : [ resources : [ post : [ schema : MyApp.Posts.Schemas.Post ] , category : [ schema : MyApp.Posts.Schemas.Category ] ] ] , products : [ resources : [ product : [ schema : MyApp.Products.Schemas.Product ] , category : [ schema : MyApp.Products.Schemas.Category ] ] ] ] Dashboard page Kaffy supports dashboard customizations through widgets . Currently, kaffy provides support for 4 types of widgets: text widgets. Suitable for display relatively long textual information. Candidates: a short review, a specific message for the admin, etc. tidbit widgets. Suitable for tiny bits of information (one word, or one number). Cadidates: total sales, a specific date, system status (&quot;Healthy&quot;, &quot;Down&quot;), etc. progress widgets. Suitable for measuring progress in terms of percentages. Candidates: task progress, survey results, memory usage, etc. chart widgets. Suitable for displaying chart data with X and Y values. Candidates: any measurable number over a period of time (e.g. sales, visits, etc). Widgets have shared options: :type (required) is the type of the widget. Valid options are text , tidbit , progress , and chart . :title (required) is the title for the widget. What this widget is about. :content (required) is the main content of the widget. This can be a string or a map depending on the type of widget. :order (optional) is the displaying order of the widget. Widgets are display in order based on this value. The default value is 999. :width (optional) is the width the widget should occupy on the page. Valid values are 1 to 12. The default for tidbits is 3 and the others 6. :percentage (required for progress widgets) is the percentage value for the progress. This must be an integer. :icon (optional for tidbit widgets) is the icon displayed next to the tidbit's content . Any FontAwesome-valid icon is valid here. For example: thumbs-up . When defining a chart widget, the content must be a map with the following required keys: :x must be a list of values for the x-axis. :y must be a list of numbers (integers/floats) for the y-axis. :y_title must be a string describing :y (e.g. USD, Transactions, Visits, etc) To create widgets, define widgets/2 in your admin modules. widgets/2 takes a schema and a conn and must return a list of widget maps: defmodule MyApp.Products.ProductAdmin do def widgets ( _schema , _conn ) do [ %{ type : &quot;tidbit&quot; , title : &quot;Average Reviews&quot; , content : &quot;4.7 / 5.0&quot; , icon : &quot;thumbs-up&quot; , order : 1 , width : 6 , } , %{ type : &quot;progress&quot; , title : &quot;Pancakes&quot; , content : &quot;Customer Satisfaction&quot; , percentage : 79 , order : 3 , width : 6 , } , %{ type : &quot;chart&quot; , title : &quot;This week&#39;s sales&quot; , order : 8 , width : 12 , content : %{ x : [ &quot;Mon&quot; , &quot;Tue&quot; , &quot;Wed&quot; , &quot;Thu&quot; , &quot;Today&quot; ] , y : [ 150 , 230 , 75 , 240 , 290 ] , y_title : &quot;USD&quot; } } ] end end Kaffy will collect all widgets from all admin modules and orders them based on the :order option if present and displays them on the dashboard page. Side Menu Custom Links Kaffy provides support for adding custom links to the side navigation menu. defmodule MyApp.Products.ProductAdmin do def custom_links ( _schema ) do [ %{ name : &quot;Source Code&quot; , url : &quot;https://example.com/repo/issues&quot; , order : 2 , location : :top , icon : &quot;paperclip&quot; } , %{ name : &quot;Products On Site&quot; , url : &quot;https://example.com/products&quot; , location : :sub , target : &quot;_blank&quot; } , ] end end custom_links/1 takes a schema and should return a list of maps with the following keys: :name to display as the text for the link. :url to contain the actual URL. :method the method to use with the link. :order to hold the displayed order of this link. All :sub links are ordered under the schema menu item directly before the following schema. :location can be either :sub or :top . :sub means it's under the schema sub-item. :top means it's displayed at the top of the menu below the &quot;Dashboard&quot; link. Links are ordered based on the :order value. The default value is :sub . :icon is the icon displayed next to the link. Any FontAwesome-valid icon is valid here. For example: paperclip . :target to contain the target to open the link: _blank or _self . _blank will open the link in a new window/tab, _self will open the link in the same window. The default value is _self . Custom Pages Kaffy allows you to add custom pages like the following: To add custom pages, you need to define the custom_pages/2 function in your admin module: defmodule MyApp.Products.ProductAdmin do def custom_pages ( _schema , _conn ) do [ %{ slug : &quot;my-own-thing&quot; , name : &quot;Secret Place&quot; , view : MyAppWeb.ProductView , template : &quot;custom_product.html&quot; , assigns : [ custom_message : &quot;one two three&quot; ] , order : 2 } ] end end The custom_pages/2 function takes a schema and a conn and must return a list of maps corresponding to pages. The maps have the following keys: :slug to indicate the url of the page, e.g., /admin/p/my-own-thing . :name for the name of the link on the side menu. :view to set the view from your own app. :template to set the custom template you want to render in Kaffy's layout. :assigns (optional) to hold the assigns for the template. Default to an empty list. :order is the order of the page among other pages in the side menu. Index pages The index/1 function takes a schema and must return a keyword list of fields and their options. If the options are nil , Kaffy will use default values for that field. If this function is not defined, Kaffy will return all fields with their respective values. defmodule MyApp.Blog.PostAdmin do def popular? ( p ) do if ( p . popular ) , do : &quot;✅&quot; , else : &quot;❌&quot; end def index ( _ ) do [ title : nil , views : %{ name : &quot;Hits&quot; } , date : %{ name : &quot;Date Added&quot; , value : fn p -&gt; p . inserted_at end } , popular : %{ name : &quot;Popular?&quot; , value : fn p -&gt; popular? ( p ) end } , ] end end Result Notice that the keyword list keys don't necessarily have to be schema fields as long as you provide a :value option. You can also provide some basic column-based filtration by providing the :filters option: defmodule MyApp.Products.ProductAdmin do def index ( _ ) do [ title : nil , category_id : %{ value : fn p -&gt; get_category! ( p . category_id ) . name end , filters : Enum . map ( list_categories ( ) , fn c -&gt; { c . name , c . id } end ) } , price : %{ value : fn p -&gt; Decimal . to_string ( p . price ) end } , quantity : nil , status : %{ name : &quot;Is it available?&quot; , value : fn p -&gt; available? ( p ) end , filters : [ { &quot;Available&quot; , &quot;available&quot; } , { &quot;Sold out&quot; , &quot;soldout&quot; } ] } , views : nil ] end end :filters must be a list of tuples where the first element is a human-frieldy string and the second element is the actual field value used to filter the records. Result If you need to change the order of the records, define ordering/1 : defmodule MyApp.Blog.PostAdmin do def ordering ( _schema ) do # order posts based on views [ desc : :views ] end end Form Pages Kaffy treats the show and edit pages as one, the form page. To customize the fields shown in this page, define a form_fields/1 function in your admin module. defmodule MyApp.Blog.PostAdmin do def form_fields ( _ ) do [ title : nil , status : %{ choices : [ { &quot;Publish&quot; , &quot;publish&quot; } , { &quot;Pending&quot; , &quot;pending&quot; } ] } , body : %{ type : :textarea , rows : 4 } , views : %{ create : :hidden , update : :readonly } , settings : %{ label : &quot;Post Settings&quot; } , slug : %{ help_text : &quot;Define your own slug for the post, if empty one will be created for you using the post title.&quot; } ] end end The form_fields/1 function takes a schema and should return a keyword list of fields and their options. The keys of the list must correspond to the schema fields. Options can be: :label - must be a string. :type - can be any ecto type in addition to :file , :textarea , and :richtext . :rows - an integer to indicate the number of rows for textarea fields. :choices - a keyword list of option and values to restrict the input values that this field can accept. :create - can be :editable which means it can be edited when creating a new record, or :readonly which means this field is visible when creating a new record but cannot be edited, or :hidden which means this field shouldn't be visible when creating a new record. It is :editable by default. :update - can be :editable which means it can be edited when updating an existing record, or :readonly which means this field is visible when updating a record but cannot be edited, or :hidden which means this field shouldn't be visible when updating record. It is :editable by default. :help_text - extra &quot;help text&quot; to be displayed with the form field. :values_fn - This allows passing in a function to populate the list of possible values for a :array field. The field will be rendered as a multi-select input. The function should be of arity 2 and the arguments are the entity and the conn. See example below Result Notice that: Even though the status field is of type :string , it is rendered as a &lt;select&gt; element with choices. The views field is rendered as &quot;readonly&quot; because it was set as :readonly for the update form. settings is an embedded schema. That's why it is rendered as such. Setting a field's type to :richtext will render a rich text editor. The :values_fn is passed the entity you are editing and the conn (in that order) and must return a list of tuples that represent the {name, value} to use in the multi select. An example of this is as follows: def form_fields ( _schema ) do [ ... . some_array_field : %{ values_fn : fn entity , conn -&gt; some_values = MyApp.Thing . fetch_values ( entity . id , conn ) Enum . map ( some_values , &amp; { &amp;1 . name , &amp;1 . id } ) end } ] Association Forms A belongs_to association should be referenced by the field name, not the association name. For example, a schema with the following association: schema &quot;my_model&quot; do ... belongs_to :owner , App.Owners.Owner ... end Would define form_fields/1 like so: def form_fields ( _ ) do [ ... owner_id : nil , ... ] end NOTE: many_to_many associations are currently not supported. Custom Form Fields You can create your own form fields very easily with Kaffy. Just follow the instructions on how to create a custom type for ecto and add 2 additional functions to the module: render_form/5 and render_index/3 . Check the below example or a better example on the comments of this issue . defmodule MyApp.Kaffy.URLField do use Ecto.Type def type , do : :string # casting input from the form and making it &quot;storable&quot; inside the database column (:string) def cast ( url ) when is_map ( url ) do name = Map . get ( url , &quot;one&quot; ) link = Map . get ( url , &quot;two&quot; ) { :ok , ~s(&lt;a href=&quot; \#{ link } &quot;&gt; \#{ name } &lt;/a&gt;) } end # if the input is not a string, return an error def cast ( _ ) , do : :error # loading the raw value from the database and turning it into a expected data type for the form def load ( data ) when is_binary ( data ) do [ [ _ , link ] ] = Regex . scan ( ~r/href=&quot;(.*)&quot;/ , data ) [ [ _ , name ] ] = Regex . scan ( ~r/&gt;(.*)&lt;/ , data ) { :ok , %{ &quot;one&quot; =&gt; name , &quot;two&quot; =&gt; link } } end # this function should return the HTML related to rendering the customized form field. def render_form ( _conn , changeset , form , field , _options ) do [ { :safe , ~s(&lt;div class=&quot;form-group&quot;&gt;) } , Phoenix.HTML.Form . label ( form , field , &quot;Web URL&quot; ) , Phoenix.HTML.Form . text_input ( form , field , placeholder : &quot;This is a custom field&quot; , class : &quot;form-control&quot; , name : &quot; \#{ form . name } [ \#{ field } ][one]&quot; , id : &quot; \#{ form . name } _ \#{ field } _one&quot; , value : get_field_value ( changeset , field , &quot;one&quot; ) ) , Phoenix.HTML.Form . text_input ( form , field , placeholder : &quot;This is a custom field&quot; , class : &quot;form-control&quot; , name : &quot; \#{ form . name } [ \#{ field } ][two]&quot; , id : &quot; \#{ form . name } _ \#{ field } _two&quot; , value : get_field_value ( changeset , field , &quot;two&quot; ) ) , { :safe , ~s(&lt;/div&gt;) } ] end # this is how the field should be rendered on the index page def render_index ( resource , field , _options ) do case Map . get ( resource , field ) do nil -&gt; &quot;&quot; details -&gt; name = details [ &quot;one&quot; ] link = details [ &quot;two&quot; ] { :safe , ~s(&lt;a href=&quot; \#{ link } &quot;&gt; \#{ name } &lt;/a&gt;) } end end defp get_field_value ( changeset , field , subfield ) do field_value = Map . get ( changeset . data , field ) Map . get ( field_value || %{ } , subfield , &quot;&quot; ) end end Customize the Queries By default Kaffy does a simple Ecto query to retrieve records. You can customize the queries used by Kaffy by using custom_index_query and custom_show_query . This allows you to preload associations to display associated data on your pages, for example. Attempting to access an association without preloading it first will result in a Ecto.Association.NotLoaded exception. defmodule MyApp.Blog.PostAdmin do def custom_index_query ( _conn , _schema , query ) do from ( r in query , preload : [ :tags ] ) end def custom_show_query ( _conn , _schema , query ) do case user_is_admin? ( conn ) do true -&gt; from ( r in query , preload : [ :history ] ) false -&gt; query end end end The custom_index_query/3 function takes a conn, the schema, and the query to customize, and it must return a query. It is called when fetching the resources for the index page. The custom_show_query/3 is identifical to custom_index_query/3 , but works when fetching a single resource in the show/edit page. It's also possible to pass opts to the Repo operation, in this case, you just have to return a tuple instead, like below: defmodule MyApp.Accounts.TenantAdmin do def custom_index_query ( _conn , _schema , query ) do { query , skip_tenant_id : true } end def custom_show_query ( _conn , _schema , query ) do { query , skip_tenant_id : true } end end Extensions Extensions allow you to define custom css, javascript, and html. For example, you need to use a specific javascript library or customize the look and feel of Kaffy. This is where extensions come in handy. Extensions are elixir modules which special functions. defmodule MyApp.Kaffy.Extension do def stylesheets ( _conn ) do [ { :safe , ~s(&lt;link rel=&quot;stylesheet&quot; href=&quot;/kaffy/somestyle.css&quot; /&gt;) } ] end def javascripts ( _conn ) do [ { :safe , ~s(&lt;script src=&quot;https://example.com/javascript.js&quot;&gt;&lt;/script&gt;) } ] end end There are currently 2 special functions supported in extensions: stylesheets/1 and javascripts/1 . Both functions take a conn and must return a list of safe strings. stylesheets/1 will add whatever you include at the end of the &lt;head&gt; tag. javascripts/1 will add whatever you include there just before the closing &lt;/body&gt; tag. Once you have your extension module, you need to add it to the extensions list in config: config :kaffy , # other settings extensions : [ MyApp.Kaffy.Extension ] You can check this issue to see an example which uses extensions with custom fields. Embedded Schemas and JSON Fields Kaffy has support for ecto's embedded schemas and json fields. When you define a field as a :map , Kaffy will automatically display a textarea with a placeholder to hint that JSON content is expected. When you have an embedded schema, Kaffy will try to render each field inline with the form of the parent schema. Search Kaffy provides very basic search capabilities. Currently, only :string and :text fields are supported for search. If you need to customize the list of fields to search against, define the search_fields/1 function. defmodule MyApp.Blog.PostAdmin do def search_fields ( _schema ) do [ :title , :slug , :body ] end end Kaffy allows to search for fields across associations. The following tells kaffy to search posts by title and body and category's name and description: # Post has a belongs_to :category association defmodule MyApp.Blog.PostAdmin do def search_fields ( _schema ) do [ :title , :body , category : [ :name , :description ] ] end end This function takes a schema and returns a list of schema fields that you want to search. All the fields must be of type :string or :text . If this function is not defined, Kaffy will return all :string and :text fields by default. Authorization Kaffy supports basic authorization for individual schemas by defining authorized?/2 . defmodule MyApp.Blog.PostAdmin do def authorized? ( _schema , conn ) do MyApp.Blog . can_see_posts? ( conn . assigns . user ) end end authorized?/2 takes a schema and a Plug.Conn struct and should return a boolean value. If it returns false , the request is redirected to the dashboard with an unauthorized message. Note that the resource is also removed from the resources list if authorized?/2 returns false. Changesets Kaffy supports separate changesets for creating and updating schemas. Just define create_changeset/2 and update_changeset/2 . Both of them are passed the schema and the attributes. defmodule MyApp.Blog.PostAdmin do def create_changeset ( schema , attrs ) do # do whatever you want, must return a changeset MyApp.Blog.Post . my_customized_changeset ( schema , attrs ) end def update_changeset ( entry , attrs ) do # do whatever you want, must return a changeset MyApp.Blog.Post . update_changeset ( entry , attrs ) end end If either function is not defined, Kaffy will try calling Post.changeset/2 . And if that is not defined, Ecto.Changeset.change/2 will be called. Singular vs Plural Some names do not follow the &quot;add an s&quot; rule. Sometimes you just need to change some terms to your liking. This is why singular_name/1 and plural_name/1 are there. defmodule MyApp.Blog.PostAdmin do def singular_name ( _ ) do &quot;Article&quot; end def plural_name ( _ ) do &quot;Terms&quot; end end Custom Actions Single Resource Actions Kaffy supports performing custom actions on single resources by defining the resource_actions/1 function. defmodule MyApp.Blog.ProductAdmin def resource_actions ( _conn ) do [ publish : %{ name : &quot;Publish this product&quot; , action : fn _c , p -&gt; restock ( p ) end } , soldout : %{ name : &quot;Sold out!&quot; , action : fn _c , p -&gt; soldout ( p ) end } ] end defp restock ( product ) do update_product ( product , %{ &quot;status&quot; =&gt; &quot;available&quot; } ) end defp soldout ( product ) do case product . id == 3 do true -&gt; { :error , product , &quot;This product should never be sold out!&quot; } false -&gt; update_product ( product , %{ &quot;status&quot; =&gt; &quot;soldout&quot; } ) end end Result resource_actions/1 takes a conn and must return a keyword list. The keys must be atoms defining the unique action &quot;keys&quot;. The values are maps providing a human-friendly :name and an :action that is an anonymous function with arity 2 that takes a conn and the record. Actions must return one of the following: {:ok, record} indicating the action was performed successfully. {:error, changeset} indicating there was a validation error. {:error, record, custom_error} to communicate a custom error message to the user where custom_error is a string. List Actions Kaffy also supports actions on a group of resources. You can enable list actions by defining list_actions/1 . defmodule MyApp.Products.ProductAdmin do def list_actions ( _conn ) do [ change_price : %{ name : &quot;Change the price&quot; , inputs : [ %{ name : &quot;new_price&quot; , title : &quot;New Price&quot; , default : &quot;3&quot; } ] , action : fn _conn , products , params -&gt; change_price ( products , params ) end } , soldout : %{ name : &quot;Mark as soldout&quot; , action : fn _ , products -&gt; list_soldout ( products ) end } , restock : %{ name : &quot;Bring back&quot; , action : fn _ , products -&gt; bring_back ( products ) end } , not_good : %{ name : &quot;Error me out&quot; , action : fn _ , _ -&gt; { :error , &quot;Expected error&quot; } end } ] end defp change_price ( products , params ) do new_price = Map . get ( params , &quot;new_price&quot; ) |&gt; Decimal . new ( ) Enum . map ( products , fn p -&gt; Ecto.Changeset . change ( p , %{ price : new_price } ) |&gt; Bakery.Repo . update ( ) end ) :ok end end Result list_actions/1 takes a conn and must return a keyword list. The keys must be atoms defining the unique action &quot;keys&quot;. The values are maps providing a human-friendly :name and an :action that is an anonymous function with arity 2 that takes a conn and a list of selected records. The change_price action is a multi-step action. The defined :inputs option will display a popup with a form that contains defined in this option. :inputs should be a list of maps. Each input must have a :name , a :title , and a :default value. After submitting the popup form, the extra values, along with the selected resources, are passed to the :action function. In the example above, change_price/2 will receive the selected products with a map of extra inputs, like: %{&quot;new_price&quot; =&gt; &quot;3.5&quot;} for example. List actions must return one of the following: :ok indicating the action was performed successfully. {:error, custom_error} to communicate a custom error message to the user where custom_error is a string. Callbacks Sometimes you need to execute certain actions when creating, updating, or deleting records. Kaffy has your back. There are a few callbacks that are called every time you create, update, or delete a record. These callbacks are: before_insert/2 before_update/2 before_delete/2 before_save/2 after_save/2 after_delete/2 after_update/2 after_insert/2 before_* functions are passed the current conn and a changeset. after_* functions are passed the current conn and the record itself. With the exception of before_delete/2 and after_delete/2 which are both passed the current conn and the record itself. before_(create|save|update)/2 must return {:ok, changeset} to continue. before_delete/2 must return {:ok, record} to continue. All after_* functions must return {:ok, record} to continue. To prevent the chain from continuing and roll back any changes: before_(create|save|update)/2 must return {:error, changeset} . before_delete/2 must return {:error, record, &quot;Customized error message} . All after_* functions must return {:error, record, &quot;Customized error message&quot;} . When creating a new record, the following functions are called in this order: before_insert/2 before_save/2 inserting the record happens here: Repo.insert/1 after_save/2 after_insert/2 When updating an existing record, the following functions are called in this order: before_update/2 before_save/2 updating the record happens here: Repo.update/1 after_save/2 after_update/2 When deleting a record, the following functions are called in this order: before_delete/2 deleting the record happens here: Repo.delete/1 after_delete/2 It's important to know that all callbacks are run inside a transaction. So in case of failure, everything is rolled back even if the operation actually happened. defmodule MyApp.Blog.PostAdmin do def before_insert ( conn , changeset ) do case conn . assigns . user . username == &quot;aesmail&quot; do true -&gt; { :error , changeset } # aesmail should never create a post false -&gt; { :ok , changeset } end end def after_insert ( _conn , post ) do { :error , post , &quot;This will prevent posts from being created&quot; } end def before_delete ( conn , post ) do case conn . assigns . user . role do &quot;admin&quot; -&gt; { :ok , post } _ -&gt; { :error , post , &quot;Only admins can delete posts&quot; } end end end Overwrite actions Sometimes you may need to overwrite the way Kaffy is creating, updating, or deleting records. You can define you own Admin function to perform those actions. This can be useful if you are creating complex records, importing files, etc... The function that can be overwritten are: insert/2 update/2 delete/2 insert/2 , update/2 &amp; delete/2 functions are passed the current conn and a changeset. They must return {:ok, record} to continue. defmodule MyApp.Blog.PostAdmin do def insert ( conn , changeset ) do entry = Post . create_complex_post ( conn . params ) { :ok , entry } end def update ( conn , changeset ) do entry = Post . update_complex_post ( conn . params [ &quot;id&quot; ] ) { :ok , entry } end def delete ( conn , changeset ) do entry = Post . delete_complex_post ( conn . params [ &quot;id&quot; ] ) { :ok , entry } end end Scheduled Tasks Kaffy supports simple scheduled tasks. Tasks are functions that are run periodically. Behind the scenes, they are put inside GenServer s and supervised with a DynamicSupervisor . To setup scheduled tasks, first define a task_[task_name]/1 function in your admin module that returns a list of tasks: defmodule MyApp.Products.ProductAdmin do def task_products do [ %{ name : &quot;Cache Product Count&quot; , initial_value : 0 , every : 15 , action : fn _v -&gt; count = Bakery.Products . cache_product_count ( ) # &quot;count&quot; will be passed to this function in its next run. { :ok , count } end } , %{ name : &quot;Delete Fake Products&quot; , every : 60 , initial_value : nil , action : fn _ -&gt; Bakery.Products . delete_fake_products ( ) { :ok , nil } end } ] end end Once this is done, add the admin module to the scheduled_tasks option in your config: config :kaffy , ... scheduled_tasks : [ MyApp.Products.ProductAdmin ] A new &quot;Tasks&quot; menu item will show up (below the Dashboard item) with your tasks as well as some tiny bits of information about each task like the following image: The task_[task_name]/1 function takes a schema and must return a list of tasks. A task is a map with the following keys: :name to hold a short description for the task. :initial_value to pass to the task's action in its first run. :every to indicate the number of seconds between each run. :action to hold an anonymous function with arity/1. The initial_value is passed to the action function in its first run. The action function must return one of the following values: {:ok, value} which indicates a successful run. The value will be passed to the action function in its next run. {:error, value} which indicates a failed run. The value will be saved and passed again to the action function in its next run. If the action function crashes, the task will be brought back up again in its initial state that is defined in the task_[task_name]/1 function and the &quot;Started&quot; time will change to indicate the new starting time. This will also reset the successful and failed run counts to 0. Note that since scheduled tasks are run with GenServer s, they are stored and kept in memory. Having too many scheduled tasks under low memory conditions can cause an out of memory exception. Scheduled tasks should be used for simple, non-critical operations.","ref":"readme.html#customizations","title":"README - Customizations","type":"extras"},{"doc":"A few points that encouraged the creation and development of Kaffy: Taking contexts into account. Supporting contexts makes the admin interface better organized. Can handle as many schemas as necessary. Whether we have 1 schema or 1000 schemas, the admin interface should adapt well. Have a visually pleasant user interface. This might be subjective. No generators or generated templates. I believe the less files there are the better. This also means it's easier to upgrade for users when releasing new versions. This might mean some flexibility and customizations will be lost, but it's a trade-off. Existing schemas/contexts shouldn't have to be modified. I shouldn't have to change my code in order to adapt to the package, the package should adapt to my code. Should be easy to use whether with a new project or with existing projects with a lot of schemas. Adding kaffy should be as easy for existing projects as it is for new ones. Highly flexible and customizable. Provide as many configurable options as possible. As few dependencies as possible. Currently kaffy only depends on phoenix and ecto. Simple authorization. I need to limit access for some admins to some schemas. Sensible, modifiable, default assumptions. When the package assumes something, this assumption should be sensible and modifiable when needed.","ref":"readme.html#the-driving-points","title":"README - The Driving Points","type":"extras"}]